#version 430


layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;
layout (location = 3) in ivec4 boneIDs;
layout (location = 4) in vec4 weights;

uniform mat4 lightSpaceMatrix;
uniform mat4 modelMatrix;
uniform mat3 normalMatrix;

const int MAX_BONES = 100;
uniform mat4 bones[MAX_BONES];

uniform bool animated;

void main() 
{
	if (animated) {
		mat4 boneTransform = bones[boneIDs[0]] * weights[0];
		boneTransform += bones[boneIDs[1]] * weights[1];
		boneTransform += bones[boneIDs[2]] * weights[2];
		boneTransform += bones[boneIDs[3]] * weights[3];
		gl_Position = lightSpaceMatrix * modelMatrix * boneTransform * vec4(position, 1.0);
	} else {
		gl_Position = lightSpaceMatrix * modelMatrix * vec4(position, 1.0);
	}
}